//% color="#e6ab37" iconWidth=50 iconHeight=40
namespace supplementary{

    //% block="初始化线程库" blockType="command"
    export function Iint(parameter: any, block: any) {
        Generator.addImport("import threading");
    }

    //% block="对象名[THR]实例化线程对象[RENAME]并启动" blockType="command"
    //% THR.shadow="normal"   THR.defl="x"
    //% RENAME.shadow="normal"   RENAME.defl="threadfuc"
    export function thread(parameter: any, block: any){ 
        let thr = parameter.THR.code
        let rename = parameter.RENAME.code
        Generator.addCode(`${thr} = threading.Thread(target=${rename}, args=(record_queue,))`);
        Generator.addCode(`x.start()`);

   }

    //% block="---"
    export function noteSep1() {

    }

    //% block="创建文件夹[FLO]来保存数据 " blockType="command"
    //% FLO.shadow="normal"   FLO.defl="flodername"
    export function floder(parameter: any, block: any){
        let flo = parameter.FLO.code
        Generator.addImport("import os");
        Generator.addCode(`
if not os.path.exists("${flo}"):
    os.mkdir("${flo}")`);
        Generator.addCode(`dataset_path = os.path.join("${flo}")`);
        Generator.addCode(`
if not os.path.exists(dataset_path):
    os.mkdir(dataset_path)`)
    }

    //% block="初始化队列[QUENAME1]来存储数据" blockType="command"
    //% QUENAME1.shadow="normal"   QUENAME1.defl="x"
    export function init_queue(parameter: any, block: any){
        let que1 = parameter.QUENAME1.code
        Generator.addImport("from queue import Queue"); 
        Generator.addCode(`${que1} = Queue()`);
   
   }

    //% block="刷新队列[QUENAME2]" blockType="command"
    //% QUENAME2.shadow="normal"   QUENAME2.defl="x"
    export function queue_clear(parameter: any, block: any){ 
        let que2 = parameter.QUENAME2.code
        Generator.addCode(`${que2}.queue.clear()`);
   
   }

    //% block="将数据[QUEDATA]导入队列[QUENAME3]" blockType="command"
    //% QUEDATA.shadow="normal"   QUEDATA.defl="data"
    //% QUENAME3.shadow="normal"   QUENAME3.defl="x"
    export function queue_put(parameter: any, block: any){ 
        let quedata = parameter.QUEDATA.code
        let que3 = parameter.QUENAME3.code
        Generator.addCode(`${que3}.put(${quedata}) `);

   }
    //% block="从队列中获取数据[QUEDATA2]" blockType="command"
    //% QUEDATA2.shadow="normal"   QUEDATA2.defl="data"
    export function queue_get(parameter: any, block: any){ 
        let quedata2 = parameter.QUEDATA2.code
        Generator.addCode(`${quedata2} = queue.get()`);
   }

    //% block="---"
    export function noteSep2() {

    }

    //% block="将预测标签映射为名称" blockType="reporter"
    export function map_label(parameter: any, block: any){ 
        Generator.addCode(`mapping_label[prediction[0]]`);
   }

    //% block="对象名[NAME2]剪裁数据[DATA]并保留[NM1]位小数" blockType="command"
    //% NAME2.shadow="normal"   NAME2.defl="d1"
    //% DATA.shadow="normal"   DATA.defl="df_name"
    //% NM1.shadow="normal"   NM1.defl="5"
    export function form(parameter: any, block: any){ 
        let name2 = parameter.NAME2.code
        let data = parameter.DATA.code
        let nm1 = parameter.NM1.code
        Generator.addCode(`
${name2}=${data}.head(1).to_dict()
for key in ${name2}:
    ${name2}[key] = {0: round(d1[key][0], ${nm1})}
        `);

   }



    //% block="新建TXT文件录入加速度数据[VDATA]文件编号[COUNTS]采集时长[CTIME]" blockType="command"
    //% VDATA.shadow="normal"   VDATA.defl="d1"
    //% COUNTS.shadow="normal"   COUNTS.defl="df_name"
    //% CTIME.shadow="normal"   CTIME.defl="5"
    export function txtfile(parameter: any, block: any){
        let vdata = parameter.VDATA.code
        let counts = parameter.COUNTS.code
        let ctime = parameter.CTIME.code
        Generator.addImport("import csv"); 
        Generator.addCode(`

with open('{}/activity_data_{}.txt'.format(dataset_path,${counts}), 'w') as csvfile:
    field_names = ['timestamp', 'x-axis', 'y-axis', 'z-axis']
    writer = csv.DictWriter(csvfile, fieldnames=field_names)
    writer.writerow({'timestamp':'timestamp', 'x-axis':'x-axis', 'y-axis':'y-axis', 'z-axis':'z-axis'})
    now = time.time() 
    while time.time() - now < ${ctime}:
        ${vdata} = queue.get()
        clear_output(wait=True)
        writer.writerow({'timestamp':time.time_ns() // 1_000_000, 'x-axis':v1, 'y-axis':v2, 'z-axis':v3}) 
        
`);
   
   }

    //% block="实时绘制加速度数值波形" blockType="command"
    export function draw(parameter: any, block: any){ 
        Generator.addCode(`plotter.multiplot([int(60*v1), int(60*v2), int(60*v3)])`);
   }



    //% block="对象名[NAME1]创建DataFrame存储统计特征" blockType="command"
    //% NAME1.shadow="normal"   NAME1.defl="df_statistic"
    export function dataframe(parameter: any, block: any){ 
        let name1 = parameter.NAME1.code
        Generator.addCode(`
d = {'x-acc-mean' :x_acc_mean,
    'y-acc-mean' :y_acc_mean,
    'z-acc-mean' :z_acc_mean,
    'x-acc-std':x_acc_std,
    'y-acc-std':y_acc_std,
    'z-acc-std':z_acc_std,
    'xy-acc-cor':xy_acc_cor,
    'yz-acc-cor':yz_acc_cor,
    'xz-acc-cor':xz_acc_cor,
    }
${name1} = pd.DataFrame(d)
        `);

   }


    //% block="初始化动图窗口宽[WID]高[HIG]通道数[CHA]" blockType="command"
    //% WID.shadow="number"   WID.defl="240"
    //% HIG.shadow="number"   HIG.defl="320"
    //% CHA.shadow="number"   CHA.defl="3"
    export function init_plotter(parameter: any, block: any){ 
        let wid = parameter.WID.code
        let hig = parameter.HIG.code
        let cha = parameter.CHA.code
        Generator.addImport("from opencv_multiplot import Plotter");
        Generator.addCode(`plotter = Plotter(${wid}, ${hig}, ${cha})`);
   
   }


    //%block="清空输出"blockType="command"
    export function clear(parameter: any, block: any){
        Generator.addImport("from IPython.display import clear_output");
        Generator.addCode(`clear_output(wait=True)`)
    }
}